from z3 import *
from random import randint
import time

communicationCost = Real('communicationCost')
computationCost = Real('computationCost')
communicationCost1 = Real('communicationCost1')
computationCost1 = Real('computationCost1')
nTask = 11
nNodes = 6
nUsers = 1
nConstraints = 2
batteryLevel = randint(0,100)


tasks = [ [ Real("x_%s_%s" % (0, 0)) for c in range(3) ] 
      for r in range(nTask*nUsers) ]

nodes = [ [ Real("x_%s_%s" % (0, 0)) for c in range(6) ] 
      for r in range(nNodes+nUsers-1) ]

#{task, node}
assignement = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
      for r in range(nTask*nUsers) ]

#{node, user}
RAMresources = [ [ Real("RAM_%s_%s" % (r,c)) for c in range(nUsers+nUsers-1) ] 
for r in range(nNodes) ]

constraints = [ [ Real("cons_%s" % (0)) for c in range(9) ] 
      for r in range(nConstraints) ]


#data to be transmitted between tasks
relation = [ [ 0 for c in range(nTask) ] 
      for r in range(nTask) ]

relation[1][2] = 30 * 8
relation[2][3] = 30000 * 8
relation[3][4] = 340000 * 8
relation[4][5] = 33000 * 8
relation[5][6] = 25000 * 8
relation[3][7] = 340000 * 8
relation[7][8] = 20000 * 8
relation[7][9] = 20000 * 8
relation[9][10] = 1500 * 8

#{CPU, RAM, user}
aux = 0
for x in range(0, nUsers):
	tasks[aux][0] = 300000 #CameraCalibration
	tasks[aux][1] = 10
	tasks[aux][2] = x
	tasks[aux+1][0] = 200 #RequestFrame
	tasks[aux+1][1] = 10
	tasks[aux+1][2] = x
	tasks[aux+2][0] = 4000 #CaptureFrame
	tasks[aux+2][1] = 15
	tasks[aux+2][2] = x
	tasks[aux+3][0] = 6000000 #getFeatures
	tasks[aux+3][1] = 45
	tasks[aux+3][2] = x
	tasks[aux+4][0] = 400000 #poseEstimation
	tasks[aux+4][1] = 50
	tasks[aux+4][2] = x
	tasks[aux+5][0] = 400000 #consultObject
	tasks[aux+5][1] = 75
	tasks[aux+5][2] = x
	tasks[aux+6][0] = 40000 #overlayContent
	tasks[aux+6][1] = 100
	tasks[aux+6][2] = x
	tasks[aux+7][0] = 60000000 #updateMap
	tasks[aux+7][1] = 200
	tasks[aux+7][2] = x
	tasks[aux+8][0] = 400000 #updateTracker
	tasks[aux+8][1] = 120
	tasks[aux+8][2] = x
	tasks[aux+9][0] = 700000000 #lookForObjects
	tasks[aux+9][1] = 320
	tasks[aux+9][2] = x
	tasks[aux+10][0] = 200000 #lookForObjects
	tasks[aux+10][1] = 150
	tasks[aux+10][2] = x
	aux = aux + nTask

#[0] max time to be executed
#[1] number of tasks involved in the restriction
#[2...n] index of the involved tasks
constraints[0][0] = 0.034
constraints[0][1] = 7
constraints[0][2] = 0
constraints[0][3] = 1
constraints[0][4] = 2
constraints[0][5] = 3
constraints[0][6] = 4
constraints[0][7] = 5
constraints[0][8] = 6
constraints[1][0] = 0.51
constraints[1][1] = 3
constraints[1][2] = 3
constraints[1][3] = 4
constraints[1][4] = 5

#{CPU, Bandwidth. Upload Cost, k, RAM, policy}
for x in range(0, nUsers):
	nodes[x][0] = 30000000
	nodes[x][1] = 3000000
	nodes[x][2] = 800
	nodes[x][3] = 0.0000001 
	nodes[x][4] = 4000.0
	nodes[x][5] = 1

nodes[nUsers][0] = 20000000
nodes[nUsers][1] = 90000000
nodes[nUsers][2] = 1300
nodes[nUsers][3] = 0.000000008
nodes[nUsers][4] = 8000

nodes[nUsers + 1][0] = 80000000
nodes[nUsers + 1][1] = 10000000
nodes[nUsers + 1][2] = 1700
nodes[nUsers + 1][3] = 0.00000005
nodes[nUsers + 1][4] = 4000

nodes[nUsers + 2][0] = 90000000
nodes[nUsers + 2][1] = 100000000
nodes[nUsers + 2][2] = 1100
nodes[nUsers + 2][3] = 0.0000000075
nodes[nUsers + 2][4] = 8000

nodes[nUsers + 3][0] = 8000000000
nodes[nUsers + 3][1] = 700000000
nodes[nUsers + 3][2] = 1000
nodes[nUsers + 3][3] = 0.0000000000009
nodes[nUsers + 3][4] = 16000.0

nodes[nUsers + 4][0] = 3000000000
nodes[nUsers + 4][1] = 300000000
nodes[nUsers + 4][2] = 900
nodes[nUsers + 4][3] = 0.000000000001
nodes[nUsers + 4][4] = 32000.0

#policy according to the battery level of the user's node
if batteryLevel >= 75:
	nodes[nUsers][5] = 1
	nodes[nUsers + 1][5] = 1
	nodes[nUsers + 2][5] = 1
	nodes[nUsers + 3][5] = 0.5
	nodes[nUsers + 4][5] = 0.5
elif batteryLevel < 75 and batteryLevel >= 50:
	nodes[nUsers][5] = 0.75
	nodes[nUsers + 1][5] = 0.75
	nodes[nUsers + 2][5] = 0.75
	nodes[nUsers + 3][5] = 0.25
	nodes[nUsers + 4][5] = 0.25
elif batteryLevel < 50 and batteryLevel >= 25:
	nodes[nUsers][5] = 0.5
	nodes[nUsers + 1][5] = 0.5
	nodes[nUsers + 2][5] = 0.5
	nodes[nUsers + 3][5] = 0.25
	nodes[nUsers + 4][5] = 0.25
elif batteryLevel < 25:	
	nodes[nUsers][5] = 0
	nodes[nUsers + 1][5] = 0
	nodes[nUsers + 2][5] = 0
	nodes[nUsers + 3][5] = 0
	nodes[nUsers + 4][5] = 0

timeBefore = time.time()

opt = Optimize()

opt.add([Sum([If(assignement [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
opt.add([Sum([If(RAMresources [m][u] >= 0,1,0) for u in range(nUsers)]) == nUsers for m in range(nNodes)])
opt.add([Sum([RAMresources [m][u] for u in range(nUsers)]) <= nodes[m][4] for m in range(nNodes)])

#tasks t1,t3 and t7 are assigned to the user's node
opt.add(Sum([If(assignement [0 + nTask*u][u],1,0)* If(assignement [2 + nTask*u][u],1,0) * If(assignement [6 + nTask*u][u],1,0)  for u in range(nUsers)]) == nUsers)

#RAM assignement for each node and user
for u in range(0, nUsers):
	opt.add([Sum([assignement[t+nTask*u][m]*tasks[t+nTask*u][1] for t in range(nTask)]) <= RAMresources[m][u] for m in range(nNodes)])

#time restrictions
for c in range(0, nConstraints):
	opt.add([(Sum([simplify(assignement[constraints[c][i]+(u*nTask)][m]*If(assignement[constraints[c][j]+(u*nTask)][m],0,1)*relation[constraints[c][i]][constraints[c][j]]*1000000/nodes[m][1])for j in range(2, 2 + constraints[c][1])]) + (assignement[constraints[c][i]+(u*nTask)][m]*tasks[constraints[c][i]+(u*nTask)][0]/nodes[m][0]))*1000000 <= constraints[c][0]*1000000 for i in range(2, 2 + constraints[c][1])  for m in range(nNodes) for u in range(nUsers)])

opt.add(communicationCost == Sum([Sum([Sum([Sum([simplify(assignement[i + u*nTask][m]*If(assignement[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]))
opt.add(computationCost == Sum([Sum([simplify(assignement[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2) *nodes[m][5]) for i in range(nTask*nUsers)]) for m in range(nNodes)]))
opt.minimize(communicationCost + computationCost)

opt.add(communicationCost1 == Sum([Sum([Sum([simplify(assignement[i + u*nTask][0]*If(assignement[j+ u*nTask][0],0,1)*(nodes[0][2]*(relation[i][j]/nodes[0][1])*nodes[0][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]))
opt.add(computationCost1 == Sum(Sum([simplify(assignement[i][0] * nodes[0][3] * tasks[i][0] * (nodes[0][0]**2) *nodes[0][5]) for i in range(nTask*nUsers)])))

print(opt.check())
m = opt.model()
timeAfter = time.time()
print(m)
print('\n')
print('Battery level (user node): ' + str(batteryLevel) + '%')
print('Energy consumption in the DI: ' + str(m[computationCost].numerator_as_long()/m[computationCost].denominator_as_long() + m[communicationCost].numerator_as_long()/m[communicationCost].denominator_as_long()) + ' (J)')
print('Energy consumption in the user node: ' + str(m[computationCost1].numerator_as_long()/m[computationCost1].denominator_as_long() + m[communicationCost1].numerator_as_long()/m[communicationCost1].denominator_as_long()) + ' (J)')
totalTime = timeAfter - timeBefore
print('Execution time: ' + str(totalTime) + ' (s)')